/* $NetBSD: crt0.c,v 1.9 2002/01/23 03:55:33 thorpej Exp $ */

/*
 * Copyright (c) 1999 Klaus Klein
 * Copyright (c) 1995 Christopher G. Demetriou
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *          This product includes software developed for the
 *          NetBSD Project.  See http://www.netbsd.org/ for
 *          information about NetBSD.
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * <<Id: LICENSE,v 1.2 2000/06/14 15:57:33 cgd Exp>>
 */

#include "common.h"

void __start __P((int, char **, char **, void (*cleanup) __P((void)),
    const Obj_Entry *, struct ps_strings *));

__asm("\n"
"       .text                           \n"
"       .align  4                       \n"
"       .globl  _start                  \n"
"_start:                                \n"
"       movl    (%sp),%d0               \n"
"       movl    %a2,-(%sp)              | ps_strings    \n"
"       movl    %a0,-(%sp)              | obj           \n"
"       movl    %a1,-(%sp)              | cleanup       \n"
"       movl    %d0,%d1                 \n"
"       lsll    #2,%d1                  \n"
"       pea     (16+4)(%sp,%d1.l)       | envp = &argv[argc + 1]        \n"
"       movl    (%sp),U_SYSBSD_ENVP	| Free Pascal environment       \n"
"       pea     20(%sp)                 | argv          \n"
"       movl    (%sp),U_SYSBSD_ARGV     | Free Pascal args      \n"
"       movl    %d0,-(%sp)              | argc          \n"
"       movl    (%sp),U_SYSBSD_ARGC     | Free Pascal arg count \n"
"       jsr     __start");

__asm("\n"
"	.text				\n"
"	.align	4			\n"
"	.globl	_haltproc		\n"
"_haltproc:				\n"
"	movw	U_SYSBSD_EXITCODE,%d1	\n"
"	movl	%d1,-(%sp)		\n"
"	jsr	exit");

void
__start(argc, argv, envp, cleanup, obj, ps_strings)
        int argc;
        char **argv;
        char **envp;
        void (*cleanup) __P((void));            /* from shared loader */
        const Obj_Entry *obj;                   /* from shared loader */
        struct ps_strings *ps_strings;
{
        environ = envp;

        if ((__progname = argv[0]) != NULL) {   /* NULL ptr if argc = 0 */
                if ((__progname = _strrchr(__progname, '/')) == NULL)
                        __progname = argv[0];
                else
                        __progname++;
        }

        if (ps_strings != (struct ps_strings *)0)
                __ps_strings = ps_strings;

#ifdef DYNAMIC
        if (&_DYNAMIC != NULL)
                _rtld_setup(cleanup, obj);
#endif

#ifdef MCRT0
        atexit(_mcleanup);
        monstartup((u_long)&_eprol, (u_long)&_etext);
#endif

        atexit(_fini);
        _init();

        exit(main(argc, argv, environ));
}

/*
 * NOTE: Leave the RCS ID _after_ __start(), in case it gets placed in .text.
 */
#if defined(LIBC_SCCS) && !defined(lint)
__RCSID("$NetBSD: crt0.c,v 1.9 2002/01/23 03:55:33 thorpej Exp $");
#endif /* LIBC_SCCS and not lint */

#include "common.c"
